#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int main()
{
    int n,m,k;
    cin>>n>>m>>k;
    vector<pair<ll,ll>> nis(n);
    vector<pair<ll,ll>> mars(m);
    ll x,y;
    for(int i=0;i<n;i++){
        cin>>x>>y;
        nis[i]={x,y};
    }
    for(int i=0;i<m;i++){
        cin>>x>>y;
        mars[i]={x,y};
    }
    for(int i=0;i<n;i++)
        cout<<nis[i].first<<" "<<nis[i].second<<endl;
    for(int i=0;i<m;i++)
        cout<<mars[i].first<<" "<<mars[i].second<<endl;

    vector<pair<ll,ll>> ans(n);
    vector<bool> zauzeto(m,false);
    for(int i=0;i<min(n,m);i++){
        ll min_dis=LLONG_MAX;
        int index=0;
        for(int j=0;j<m;j++){
            ll dist=(ll)(nis[i].first-mars[j].first)*(nis[i].first-mars[j].first)+(nis[i].second-mars[j].second)*(nis[i].second-mars[j].second);
            if(min_dis>dist && zauzeto[j]==false){
                index=j;
                min_dis=dist;
            }
        }
        zauzeto[index]=true;
        ans[i]={min_dis,index};
    }
    sort(ans.begin(),ans.end()+min(n,m));
    
    return 0;
}